/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Tree = function()
{
	var tree = {};
	
	tree.initPage = function()
	{
		IconStore.addDefaultIcons();
		
		IconStore.addIconSet('Warning', 'warning.png', null, null, null, App.getRoot()+'images/');
		IconStore.addIconSet('Error', 'error.png', null, null, null, App.getRoot()+'images/');

		IconStore.addIconSet('ItemWarning', 'item-warning.png', 'item-warning-selected.png');
		IconStore.addIconSet('ItemError', 'item-error.png', 'item-error-selected.png');
		IconStore.addIconSet('ItemChildWarning', 'item-child-warning.png', 'item-child-warning-selected.png');
		IconStore.addIconSet('ItemChildError', 'item-child-error.png', 'item-child-error-selected.png');

		IconStore.addIconSet('FolderWarning', 'folder-warning.png', 'folder-warning-selected.png');
		IconStore.addIconSet('FolderError', 'folder-error.png', 'folder-error-selected.png');
		IconStore.addIconSet('FolderChildWarning', 'folder-child-warning.png', 'folder-child-warning-selected.png');
		IconStore.addIconSet('FolderChildError', 'folder-child-error.png', 'folder-child-error-selected.png');

		IconStore.addIconSet('Annotation', 'annotation.png', 'annotation-selected.png');
		IconStore.addIconSet('AnnotationWarning', 'annotation-warning.png', 'annotation-warning-selected.png');
		IconStore.addIconSet('AnnotationError', 'annotation-error.png', 'annotation-error-selected.png');
		IconStore.addIconSet('AnnotationChildWarning', 'annotation-child-warning.png', 'annotation-child-warning-selected.png');
		IconStore.addIconSet('AnnotationChildError', 'annotation-child-error.png', 'annotation-child-error-selected.png');

		IconStore.addIconSet('ProtocolParameter', 'parameter.png', 'parameter-selected.png');
		IconStore.addIconSet('ProtocolParameterWarning', 'parameter-warning.png', 'parameter-warning-selected.png');
		IconStore.addIconSet('ProtocolParameterError', 'parameter-error.png', 'parameter-error-selected.png');
		IconStore.addIconSet('ProtocolParameterChildWarning', 'parameter-child-warning.png', 'parameter-child-warning-selected.png');
		IconStore.addIconSet('ProtocolParameterChildError', 'parameter-child-error.png', 'parameter-child-error-selected.png');

		Events.addEventHandler('joust', 'joust-select', tree.onSelect);
		Events.addEventHandler('joust', 'joust-lazy-init', tree.lazyInit);
		
		Joust2.draw('joust');
	}
	
	tree.onSelect = function(event)
	{
		var url = 'info.jsp?ID='+App.getSessionId();
		url += '&nodeId='+event.target.id;
		url += '&show_failures='+Data.get('page-data', 'show-failures');
		parent.frames['info'].location.href = url;
	}
	
	tree.selectNode = function(nodeId)
	{
		Joust2.select(nodeId);
	}
	
	tree.lazyInit = function(event)
	{
		var menuElement = event.target;
		Doc.addClass(menuElement, 'working');
		try
		{
			var request = Ajax.getXmlHttpRequest();
			var url = 'ajax.jsp?ID='+App.getSessionId();
			url += '&cmd=GetSubNodes&node_id=' + menuElement.id;
			request.open("GET", url, false);
			request.send(null);
			
			var response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				Forms.showNotification(menuElement.id+'-outline', response.message);
			}
			
			Joust2.addChildren(menuElement, response.childNodes || []);
			Joust2.toggle(menuElement);
		}
		finally
		{
			Doc.removeClass(menuElement, 'working');
		}
	}
	
	return tree;
}();

Doc.onLoad(Tree.initPage);


