<%-- $Id: plotter.jsp 6612 2014-11-21 06:43:00Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http:// base.thep.lu.se/

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description, Formula.AverageMethod avgMethod)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(" data-average-method=\"").append(avgMethod.name()).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final float scale = Base.getScale(sc);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	final int bioAssaySetId = Values.getInt(request.getParameter("bioAssaySetId"));
	final int reporterIndex = Values.getInt(request.getParameter("reporterIndex"));
	final int positionIndex = Values.getInt(request.getParameter("positionIndex"));
	final String plotType = Values.getString(request.getParameter("type"), "assay");
	final int annotationTypeId = Values.getInt(request.getParameter("annotationTypeId"));
	final boolean needAverageMethod = positionIndex == ExperimentExplorer.SPOT_AVG;
	
	final BioAssaySet bas = BioAssaySet.getById(dc, bioAssaySetId);
	final RawDataType rdt = bas.getRawDataType();
	final Experiment experiment = bas.getExperiment();
	final int maxRawMappings = bas.getMaxRawMappingsForSpot();
	final IntensityTransform transform = bas.getIntensityTransform();
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bas);
	final ReporterData reporter = explorer.getReporter(dc, reporterIndex);
	final List<AnnotationType> annotationTypes = explorer.getAnnotationTypes(dc, true);
	
	List<TableColumn> formulas = new LinkedList<TableColumn>();
	DynamicUtil.addSpotColumns(formulas, dc, rdt.getChannels(), transform);
	DynamicUtil.addFormulaColumns(formulas, dc, rdt, Formula.Type.COLUMN_EXPRESSION, 
			transform, "", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(formulas, dc, bas, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(formulas, dc, rdt, "", "", "[Raw] ");
	}
	
	StringBuilder formulaOptions = new StringBuilder();
	for (TableColumn tc : formulas)
	{
		if (tc.getJepExpression() != null && tc.getDatatype().isNumerical())
		{
			if (!needAverageMethod || tc.getAverageMethod() != Formula.AverageMethod.NONE)
			{
				String jepExpression = tc.getJepExpression();
				addFormulaOption(formulaOptions, jepExpression, tc.getTitle(), tc.getDescription(), tc.getAverageMethod());
			}
		}
	}
	
	String title = HTML.encodeTags("Plot " + bas.getName());
	final boolean hasCreateFilePermission = sc.hasPermission(Permission.CREATE, Item.FILE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol-2.js,~plotter.js" styles="tabcontrol.css" />
	<base:body>
	<h1><%=title%> <base:help helpid="explorer.plotter" /></h1>
	<div id="page-data" class="datacontainer"
		data-bioassayset="<%=bioAssaySetId %>"
		data-reporter-index="<%=reporterIndex %>"
		data-position-index="<%=positionIndex %>"
	></div>
	<form name="plot">
	<div class="content bottomborder">
		<div class="absolutefull rightborder" style="right: 550px;">
	
			<table class="fullform input100 smaller">
			<tbody>
			<tr>
				<th>Plot title</th>
				<td colspan="2"><input type="text" class="text" maxlength="255" name="title" 
					value="<%=HTML.encodeTags(bas.getName())%>"></td>
			</tr>
			<tr>
				<th class="subprompt">Subtitle</th>
				<td colspan="2"><input type="text" class="text" maxlength="255" name="subTitle" 
					value="<%=HTML.encodeTags(reporter.getName())%>"></td>
			</tr>
				<tr>
					<th>Width</th>
					<td colspan="2"><input type="text" class="text" 
						name="width" id="width"
						style="width: 10em;" maxlength="10" value="900"
						> (not used by preview)</td>
				</tr>
				<tr>
					<th>Height</th>
					<td colspan="2"><input type="text" class="text" 
						name="height" id="height"
						style="width: 10em;" maxlength="10" value="600"></td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			
			<tbody class="simplesection">
				<tr>
					<th>Y-axis</th>
					<td>
					<select name="yPresets" id="yPresets" style="width: 25em;"
						data-formula-id="yFormula"
						data-label-id="yLabel"
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="yFormula" id="yFormula"></td>
					<td>
						<base:icon
							id="btnExpressionBuilderY"
							data-formula-id="yFormula"
							data-title="Y-axis expression"
							data-formula-type="COLUMN_EXPRESSION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabel" id="yLabel"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLog">Log scale</label></th>
					<td><input type="checkbox" name="yLog" id="yLog" value="1"></td>
					<td></td>
				</tr>
				<%
				if (positionIndex == ExperimentExplorer.SPOT_AVG)
				{
					%>
					<tr>
						<th class="subprompt">Average method</th>
						<td>
							<select name="averageMethod">
							<%
							for (Formula.AverageMethod method : Formula.AverageMethod.values())
							{
								if (method != Formula.AverageMethod.NONE)
								{
									%>
									<option value="<%=method.name()%>"><%=method.toString()%></option>
									<%
								}
							}
							%>
							</select>
						</td>
						<td></td>
					</tr>
					<%	
				}
				%>
				<tr>
					<th>X-axis</th>
					<td>
						<input type="radio" name="plotType" value="assay" 
							id="plotTypeAssay" <%=plotType.equals("assay") ? "checked" : ""%>
							><label for="plotTypeAssay"
							title="Creates a line/bar plot with bioassays along the x axis">Bioassays</label>
						<input type="radio" name="plotType" value="annotation" 
							id="plotTypeAnnotation" <%=plotType.equals("annotation") ? "checked" : ""%>
							><label for="plotTypeAnnotation" 
							title="Creates a box plot with annotation values along the x axis">Annotation</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Annotation</th>
					<td>
						<select name="annotationTypeId" class="selectionlist">
						<%
						for (AnnotationType at : annotationTypes)
						{
							String selected = at.getId() == annotationTypeId ? "selected" : "";
							%>
							<option value="<%=at.getId()%>" <%=selected%>><%=HTML.encodeTags(at.getName())%>
							<%
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="hideXLabels">No labels</label></th>
					<td><input type="checkbox" name="hideXLabels" id="hideXLabels" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>Plot type</th>
					<td>
						<select name="subtype">
						<option value="line">Line plot</option>
						<option value="bar">Bar plot</option>
						</select>
					<td></td>
				</tr>
			</tbody>

			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>

		</div>
		<div class="absolutefull bg-filled-50" style="width: 550px; left: auto;">
			<img src="../../../../images/plot_empty.png" id="preview" 
				style="position: absolute; top: 5px; z-index: 1;" alt="">
			<img src="../../../../images/plot_select.png" id="overlay" 
				style="position: absolute; top: 5px; z-index: 2;" alt="">
		</div>
	
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button 
			id="btnPreviewPlot"
			title="Preview" 
			image="plotter_preview.png"
			tooltip="Generate a preview of the plot" 
		/>
		<base:button 
			id="btnViewPlot"
			title="View&hellip;" 
			image="plotter.png" 
			tooltip="View a fullsized version of the plot (in a popup)" 
		/>
		<base:button 
			id="btnDownloadPlot"
			title="Download&hellip;"
			image="download.png"
			tooltip="Downlad a fullsized version of the plot to your computer" 
		/>
		<base:button 
			id="btnSavePlot"
			title="Save as&hellip;"
			image="saveas.png"
			disabled="<%=!hasCreateFilePermission%>"
			tooltip="<%=hasCreateFilePermission ? 
				"Save a fullsized version of the plot on the BASE server" :
				"You don't have permission to create files" %>" 
		/>
		<base:button id="close" title="Close" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
