<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.ITEMLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int cloneId = Values.getInt(request.getParameter("clone_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ItemList list = null;
	boolean addItems = Values.getBoolean(request.getParameter("addItems"));
	Item memberType = addItems ? Item.valueOf(request.getParameter("memberType")) : null;
	String formId = addItems ? Values.getStringOrNull(request.getParameter("formId")) : null;
	String subContext = addItems ? Values.getStringOrNull(request.getParameter("subContext")) : null;

	ItemQuery<ItemSubtype> subtypesQuery = null;
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	
	RawDataType currentRawDataType = null;

	if (itemId == 0 && cloneId == 0)
	{
		title = "Create item list";
		cc.removeObject("item");
		subtypesQuery = Base.getSubtypesQuery(null);
		
		if (memberType == null)
		{
			memberType = Item.fromValue(Values.getInt(cc.getPropertyValue("memberType")));
		}
	}
	else
	{
		list = ItemList.getById(dc, itemId == 0 ? cloneId : itemId);
		list.checkPermission(Permission.WRITE);
		memberType = list.getMemberType();
		subtypesQuery = Base.getSubtypesQuery(memberType);
		if (itemId == 0)
		{
			title = "Create copy -- " + HTML.encodeTags(list.getName());
		}
		else
		{
			cc.setObject("item", list);
			title = "Edit item list -- " + HTML.encodeTags(list.getName());
		}
		currentRawDataType = list.getRawDataType();
		try
		{
			currentSubtype = list.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
	}
	
	JSONArray jsonSubtypes = new JSONArray();
	if (subtypesQuery != null)
	{
		for (ItemSubtype subtype : subtypesQuery.list(dc))
		{
			JSONObject jsonSubtype = new JSONObject();
			jsonSubtype.put("id", subtype.getId());
			jsonSubtype.put("name", subtype.getName());
			jsonSubtype.put("description", subtype.getDescription());
			jsonSubtype.put("itemType", subtype.getMainItemType().name());
			if (currentSubtype == subtype)
			{
				jsonSubtype.put("current", 1);
			}
			jsonSubtypes.add(jsonSubtype);
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), list);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~lists.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings"/></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="list">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="clone_id" value="<%=cloneId%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		
		<div id="page-data" class="datacontainer"
			data-subtypes="<%=HTML.encodeTags(jsonSubtypes.toJSONString())%>"
		></div>

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=list != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Item list" helpid="itemlist.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=list == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("name"), "New list") : list.getName() + (itemId==0 ? " (copy)":""))%>" 
					maxlength="<%=ItemList.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Member type</th>
				<td>
					<select name="memberType" id="memberType" <%=list != null || (addItems && memberType != null) ? "disabled" : "" %> class="selectionlist unchangeable">
					<%
					for (Item mt : Metadata.getListableItems())
					{
						%>
						<option value="<%=mt.name()%>" <%=memberType == mt ? "selected" : ""%>><%=mt.toString()%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr id="subtypeRow">
				<th>Subtype</th>
				<td>
					<select name="subtype_id" id="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr id="rawDataTypeRow">
				<th>Raw data type</th>
				<td>
					<select name="rawdatatype" id="rawdatatype" class="selectionlist">
					<option value="">- any -
					<%
					for (RawDataType rdt : RawDataTypes.getRawDataTypes())
					{
						String selected = rdt.equals(currentRawDataType) ? "selected" : "";
						%>
						<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("externalId"), "") : list.getExternalId())%>" 
					maxlength="<%=ItemList.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Modify members</th>
				<td>
					<label><input type="checkbox" name="disableManual" id="disableManual" value="1"
						<%=list != null && list.getDisableManualMembers() ? "checked" : "" %>
						>Disable manual</label><br>
					<label><input type="checkbox" name="disableSyncFilters" id="disableSyncFilters" value="1"
						<%=list != null && list.getDisableSyncFilters() ? "checked" : "" %>
						>Disable synchronization filters</label>
				</td>
				<td></td>
			</tr>
			<%
			if (addItems)
			{
				%>
				<tr class="big">
					<th>Source items</th>
					<td>
						<input type="radio" name="source" id="sourceSelected" value="selected"
							data-parent-form="<%=formId%>"
							><label for="sourceSelected" id="lblSelected">Selected items</label><br>
						<input type="radio" name="source" id="sourcePage" value="page"
							><label for="sourcePage">Current page</label><br>
						<input type="radio" name="source" id="sourceAll" value="all" checked
							><label for="sourceAll">All pages</label><br>
							<input type="checkbox" name="syncFilter" id="syncFilter" value="1" checked style="margin-left:2em;"
								><label for="syncFilter">Remember current filter for future re-sync</label>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(list == null ? cc.getPropertyValue("description") : list.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (list == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
